﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using com.ihr.xbrl.om;
using java.net;
using java.util;
using com.ihr.xbrl.om.taxonomy;
using com.ihr.xbrl.om.exLinks;
using System.IO;

namespace SampleReadTaxonomyShowConceptsAndRelationships
{
    class Program
    {
        static void Main(string[] args)
        {
		/*
		 * Create a new empty DTS Container
		 */
		DTSContainer dts = DTSContainer.newEmptyContainer();
		
		/*
		 * Open the taxonomy DTS from a local file. The DTS is discovered now.
		 */
		string absolutePath = Path.GetFullPath("sampleTaxonomy.xsd");
		var uriLocal = new System.Uri(absolutePath);
		var uri = new URI(uriLocal.AbsoluteUri);
		dts.load(uri);
		
		/*
		 * Show taxonomy concepts and relationships
		 */
		Iterator iterE = dts.getConcepts();
        while (iterE.hasNext())
        {
            XMLElementDefinition el = (XMLElementDefinition)iterE.next();

            Console.WriteLine("Element name: " + el.getName());

            if (el is XBRLItem)
            {
                Console.WriteLine(" is an XBRL Item");
            }
            else if (el is XBRLTuple)
            {
                Console.WriteLine(" is an XBRL Tuple");
            }
            else
            {
                Console.WriteLine(" is an XML element that not an XBRL Item an not an XBRL Tuple");
            }

            /*
             *  feel free to access to other concept properties.
             *  See all them as methods of the XMLElementDefinition object, XBRLItem or XBRLTuple objects 
             */

            // relationships:
            Iterator iterFR = el.getFromRelationships();
            while (iterFR.hasNext())
            {
                XBRLRelationship rel = (XBRLRelationship)iterFR.next();

                Console.WriteLine("The element is the source of an XBRL relationship\n");
                Console.WriteLine("Relationship arcrole:" + rel.getArcroleType().getURI());
                Console.WriteLine("Relationship type:" + rel.getType().toString());

                /*
                 * feel free to add more information about the relationship. the object is XBRLRelationship
                 */
            }

            /*
             * Exercise: implement the same loop for the relationships the element el is the target.
             * 
             * Hint: use the method el.getToRelationships()
             */
        }
        }
    }
}
